<?php
namespace Opencart\Admin\Controller\Extension\ChargeAnywhere\Payment;
class ChargeAnywhere extends \Opencart\System\Engine\Controller {
	private $error = [];
	
	public function index(): void {
		$this->load->language('extension/chargeanywhere/payment/chargeanywhere');
		$this->load->model('extension/chargeanywhere/payment/chargeanywhere');
		$this->document->setTitle($this->language->get('heading_title'));
			
		$data['breadcrumbs'] = [[
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'])
		], [
			'text' => $this->language->get('text_extensions'),
			'href' => $this->url->link('marketplace/opencart/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment')
		], [
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/chargeanywhere/payment/chargeanywhere', 'user_token=' . $this->session->data['user_token'])
		]];
		
		$data['save'] = $this->url->link('extension/chargeanywhere/payment/chargeanywhere|save', 'user_token=' . $this->session->data['user_token']);
		$data['back'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment');
		$data['server'] = HTTP_SERVER;
		$data['catalog'] = HTTP_CATALOG;
						
		// Setting 		
		$_config = new \Opencart\System\Engine\Config();
		$_config->addPath(DIR_EXTENSION . 'chargeanywhere/system/config/');
		$_config->load('chargeanywhere');
		
		$data['setting'] = $_config->get('chargeanywhere_setting');
		if (isset($environment)) {
			$data['environment'] = $environment;
		} elseif (isset($this->request->post['payment_chargeanywhere_environment'])) {
			$data['environment'] = $this->request->post['payment_chargeanywhere_environment'];
		} elseif ($this->config->get('payment_chargeanywhere_environment')) {
			$data['environment'] = $this->config->get('payment_chargeanywhere_environment');
		} else {
			$data['environment'] = 'production';
		}
		
		if (isset($data['setting']['payment_chargeanywhere_merchant_id'])) {
			$data['merchant_id'] = $data['setting']['payment_chargeanywhere_merchant_id'];
		} elseif (isset($this->request->post['payment_chargeanywhere_merchant_id'])) {
			$data['merchant_id'] = $this->request->post['payment_chargeanywhere_merchant_id'];
		} else {
			$data['merchant_id'] = $this->config->get('payment_chargeanywhere_merchant_id');
		}

		if (isset($data['setting']['payment_chargeanywhere_email_customer'])) {
			$data['email_customer'] = $data['setting']['payment_chargeanywhere_email_customer'];
		} elseif (isset($this->request->post['payment_chargeanywhere_email_customer'])) {
			$data['email_customer'] = $this->request->post['payment_chargeanywhere_email_customer'];
		} else {
			$data['email_customer'] = $this->config->get('payment_chargeanywhere_email_customer');
		}

		if (isset($data['setting']['payment_chargeanywhere_email_merchant'])) {
			$data['email_merchant'] = $data['setting']['payment_chargeanywhere_email_merchant'];
		} elseif (isset($this->request->post['payment_chargeanywhere_email_merchant'])) {
			$data['email_merchant'] = $this->request->post['payment_chargeanywhere_email_merchant'];
		} else {
			$data['email_merchant'] = $this->config->get('payment_chargeanywhere_email_merchant');
		}

		if (isset($data['setting']['payment_chargeanywhere_secret'])) {
			$data['secret'] = $merchant_id;
		} elseif (isset($this->request->post['payment_chargeanywhere_secret'])) {
			$data['secret'] = $this->request->post['payment_chargeanywhere_secret'];
		} else {
			$data['secret'] = $this->config->get('payment_chargeanywhere_secret');
		}
		
		if (isset($data['setting']['payment_chargeanywhere_terminal_id'])) {
			$data['terminal_id'] = $merchant_id;
		} elseif (isset($this->request->post['payment_chargeanywhere_terminal_id'])) {
			$data['terminal_id'] = $this->request->post['payment_chargeanywhere_terminal_id'];
		} else {
			$data['terminal_id'] = $this->config->get('payment_chargeanywhere_terminal_id');
		}
								
		if (isset($this->request->post['payment_chargeanywhere_transaction_method'])) {
			$data['transaction_method'] = $this->request->post['payment_chargeanywhere_transaction_method'];
		} else {
			$data['transaction_method'] = $this->config->get('payment_chargeanywhere_transaction_method');
		}

		if (isset($this->request->post['payment_chargeanywhere_transaction_method'])) {
			$data['transaction_method'] = $this->request->post['payment_chargeanywhere_transaction_method'];
		} else {
			$data['transaction_method'] = $this->config->get('payment_chargeanywhere_transaction_method');
		}

		if (isset($data['setting']['payment_chargeanywhere_accept_credit'])) {
			$data['accept_credit'] = $data['setting']['payment_chargeanywhere_accept_credit'];
		} elseif (isset($this->request->post['payment_chargeanywhere_accept_credit'])) {
			$data['accept_credit'] = $this->request->post['payment_chargeanywhere_accept_credit'];
		} else {
			$data['accept_credit'] = $this->config->get('payment_chargeanywhere_accept_credit');
		}

		if (isset($data['setting']['payment_chargeanywhere_apply_credit'])) {
			$data['apply_credit'] = $data['setting']['payment_chargeanywhere_apply_credit'];
		} elseif (isset($this->request->post['payment_chargeanywhere_apply_credit'])) {
			$data['apply_credit'] = $this->request->post['payment_chargeanywhere_apply_credit'];
		} else {
			$data['apply_credit'] = $this->config->get('payment_chargeanywhere_apply_credit');
		}

		if (isset($data['setting']['payment_chargeanywhere_credit_service'])) {
			$data['credit_service'] = $data['setting']['payment_chargeanywhere_credit_service'];
		} elseif (isset($this->request->post['payment_chargeanywhere_credit_service'])) {
			$data['credit_service'] = $this->request->post['payment_chargeanywhere_credit_service'];
		} else {
			$data['credit_service'] = $this->config->get('payment_chargeanywhere_credit_service');
		}

		if (isset($data['setting']['payment_chargeanywhere_credit_fee_service'])) {
			$data['credit_fee_service'] = $data['setting']['payment_chargeanywhere_credit_fee_service'];
		} elseif (isset($this->request->post['payment_chargeanywhere_credit_fee_service'])) {
			$data['credit_fee_service'] = $this->request->post['payment_chargeanywhere_credit_fee_service'];
		} else {
			$data['credit_fee_service'] = $this->config->get('payment_chargeanywhere_credit_fee_service');
		}

		if (isset($data['setting']['payment_chargeanywhere_credit_fee_value'])) {
			$data['credit_fee_value'] = $data['setting']['payment_chargeanywhere_credit_fee_value'];
		} elseif (isset($this->request->post['payment_chargeanywhere_credit_fee_value'])) {
			$data['credit_fee_value'] = $this->request->post['payment_chargeanywhere_credit_fee_value'];
		} else {
			$data['credit_fee_value'] = $this->config->get('payment_chargeanywhere_credit_fee_value');
		}

		if (isset($data['setting']['payment_chargeanywhere_credit_apply_tax'])) {
			$data['apply_credit_tax'] = $data['setting']['payment_chargeanywhere_credit_apply_tax'];
		} elseif (isset($this->request->post['payment_chargeanywhere_credit_apply_tax'])) {
			$data['apply_credit_tax'] = $this->request->post['payment_chargeanywhere_credit_apply_tax'];
		} else {
			$data['apply_credit_tax'] = $this->config->get('payment_chargeanywhere_credit_apply_tax');
		}

		if (isset($data['setting']['payment_chargeanywhere_credit_refund'])) {
			$data['apply_credit_refund'] = $data['setting']['payment_chargeanywhere_credit_refund'];
		} elseif (isset($this->request->post['payment_chargeanywhere_credit_refund'])) {
			$data['apply_credit_refund'] = $this->request->post['payment_chargeanywhere_credit_refund'];
		} else {
			$data['apply_credit_refund'] = $this->config->get('payment_chargeanywhere_credit_refund');
		}

		if (isset($data['setting']['payment_chargeanywhere_apply_credit_convenience'])) {
			$data['apply_credit_convenience'] = $data['setting']['payment_chargeanywhere_apply_credit_convenience'];
		} elseif (isset($this->request->post['payment_chargeanywhere_apply_credit_convenience'])) {
			$data['apply_credit_convenience'] = $this->request->post['payment_chargeanywhere_apply_credit_convenience'];
		} else {
			$data['apply_credit_convenience'] = $this->config->get('payment_chargeanywhere_apply_credit_convenience');
		}

		if (isset($data['setting']['payment_chargeanywhere_credit_convenience_service'])) {
			$data['credit_convenience_service'] = $data['setting']['payment_chargeanywhere_credit_convenience_service'];
		} elseif (isset($this->request->post['payment_chargeanywhere_credit_convenience_service'])) {
			$data['credit_convenience_service'] = $this->request->post['payment_chargeanywhere_credit_convenience_service'];
		} else {
			$data['credit_convenience_service'] = $this->config->get('payment_chargeanywhere_credit_convenience_service');
		}

		if (isset($data['setting']['payment_chargeanywhere_credit_convenience_fee_value'])) {
			$data['credit_convenience_value'] = $data['setting']['payment_chargeanywhere_credit_convenience_fee_value'];
		} elseif (isset($this->request->post['payment_chargeanywhere_credit_convenience_fee_value'])) {
			$data['credit_convenience_value'] = $this->request->post['payment_chargeanywhere_credit_convenience_fee_value'];
		} else {
			$data['credit_convenience_value'] = $this->config->get('payment_chargeanywhere_credit_convenience_fee_value');
		}
		
		if (isset($data['setting']['payment_chargeanywhere_apply_credit_convenience_refund'])) {
			$data['credit_convenience_refund'] = $data['setting']['payment_chargeanywhere_apply_credit_convenience_refund'];
		} elseif (isset($this->request->post['payment_chargeanywhere_apply_credit_convenience_refund'])) {
			$data['credit_convenience_refund'] = $this->request->post['payment_chargeanywhere_apply_credit_convenience_refund'];
		} else {
			$data['credit_convenience_refund'] = $this->config->get('payment_chargeanywhere_apply_credit_convenience_refund');
		}


		if (isset($data['setting']['payment_chargeanywhere_accept_ach'])) {
			$data['accept_ach'] = $data['setting']['payment_chargeanywhere_accept_ach'];
		} elseif (isset($this->request->post['payment_chargeanywhere_accept_ach'])) {
			$data['accept_ach'] = $this->request->post['payment_chargeanywhere_accept_ach'];
		} else {
			$data['accept_ach'] = $this->config->get('payment_chargeanywhere_accept_ach');
		}

		if (isset($data['setting']['payment_chargeanywhere_apply_ach'])) {
			$data['apply_ach'] = $data['setting']['payment_chargeanywhere_apply_ach'];
		} elseif (isset($this->request->post['payment_chargeanywhere_apply_ach'])) {
			$data['apply_ach'] = $this->request->post['payment_chargeanywhere_apply_ach'];
		} else {
			$data['apply_ach'] = $this->config->get('payment_chargeanywhere_apply_ach');
		}

		if (isset($data['setting']['payment_chargeanywhere_ach_service'])) {
			$data['ach_service'] = $data['setting']['payment_chargeanywhere_ach_service'];
		} elseif (isset($this->request->post['payment_chargeanywhere_ach_service'])) {
			$data['ach_service'] = $this->request->post['payment_chargeanywhere_ach_service'];
		} else {
			$data['ach_service'] = $this->config->get('payment_chargeanywhere_ach_service');
		}

		if (isset($data['setting']['payment_chargeanywhere_ach_fee_service'])) {
			$data['ach_fee_service'] = $data['setting']['payment_chargeanywhere_ach_fee_service'];
		} elseif (isset($this->request->post['payment_chargeanywhere_ach_fee_service'])) {
			$data['ach_fee_service'] = $this->request->post['payment_chargeanywhere_ach_fee_service'];
		} else {
			$data['ach_fee_service'] = $this->config->get('payment_chargeanywhere_ach_fee_service');
		}

		if (isset($data['setting']['payment_chargeanywhere_ach_fee_value'])) {
			$data['ach_fee_value'] = $data['setting']['payment_chargeanywhere_ach_fee_value'];
		} elseif (isset($this->request->post['payment_chargeanywhere_ach_fee_value'])) {
			$data['ach_fee_value'] = $this->request->post['payment_chargeanywhere_ach_fee_value'];
		} else {
			$data['ach_fee_value'] = $this->config->get('payment_chargeanywhere_ach_fee_value');
		}


		if (isset($data['setting']['payment_chargeanywhere_ach_apply_tax'])) {
			$data['apply_ach_tax'] = $data['setting']['payment_chargeanywhere_ach_apply_tax'];
		} elseif (isset($this->request->post['payment_chargeanywhere_ach_apply_tax'])) {
			$data['apply_ach_tax'] = $this->request->post['payment_chargeanywhere_ach_apply_tax'];
		} else {
			$data['apply_ach_tax'] = $this->config->get('payment_chargeanywhere_ach_apply_tax');
		}

		if (isset($data['setting']['payment_chargeanywhere_ach_refund'])) {
			$data['apply_ach_refund'] = $data['setting']['payment_chargeanywhere_ach_refund'];
		} elseif (isset($this->request->post['payment_chargeanywhere_ach_refund'])) {
			$data['apply_ach_refund'] = $this->request->post['payment_chargeanywhere_ach_refund'];
		} else {
			$data['apply_ach_refund'] = $this->config->get('payment_chargeanywhere_ach_refund');
		}

		if (isset($data['setting']['payment_chargeanywhere_apply_ach_convenience'])) {
			$data['apply_ach_convenience'] = $data['setting']['payment_chargeanywhere_apply_ach_convenience'];
		} elseif (isset($this->request->post['payment_chargeanywhere_apply_ach_convenience'])) {
			$data['apply_ach_convenience'] = $this->request->post['payment_chargeanywhere_apply_ach_convenience'];
		} else {
			$data['apply_ach_convenience'] = $this->config->get('payment_chargeanywhere_apply_ach_convenience');
		}

		if (isset($data['setting']['payment_chargeanywhere_ach_convenience_service'])) {
			$data['ach_convenience_service'] = $data['setting']['payment_chargeanywhere_ach_convenience_service'];
		} elseif (isset($this->request->post['payment_chargeanywhere_ach_convenience_service'])) {
			$data['ach_convenience_service'] = $this->request->post['payment_chargeanywhere_ach_convenience_service'];
		} else {
			$data['ach_convenience_service'] = $this->config->get('payment_chargeanywhere_ach_convenience_service');
		}

		if (isset($data['setting']['payment_chargeanywhere_ach_convenience_fee_value'])) {
			$data['ach_convenience_value'] = $data['setting']['payment_chargeanywhere_ach_convenience_fee_value'];
		} elseif (isset($this->request->post['payment_chargeanywhere_ach_convenience_fee_value'])) {
			$data['ach_convenience_value'] = $this->request->post['payment_chargeanywhere_ach_convenience_fee_value'];
		} else {
			$data['ach_convenience_value'] = $this->config->get('payment_chargeanywhere_ach_convenience_fee_value');
		}


		if (isset($data['setting']['payment_chargeanywhere_apply_ach_convenience_refund'])) {
			$data['ach_convenience_refund'] = $data['setting']['payment_chargeanywhere_apply_ach_convenience_refund'];
		} elseif (isset($this->request->post['payment_chargeanywhere_apply_ach_convenience_refund'])) {
			$data['ach_convenience_refund'] = $this->request->post['payment_chargeanywhere_apply_ach_convenience_refund'];
		} else {
			$data['ach_convenience_refund'] = $this->config->get('payment_chargeanywhere_apply_ach_convenience_refund');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_chargeanywhere_status'])) {
			$data['status'] = $this->request->post['payment_chargeanywhere_status'];
		} else {
			$data['status'] = $this->config->get('payment_chargeanywhere_status');
		}

		if (isset($this->request->post['payment_chargeanywhere_log'])) {
			$data['log'] = $this->request->post['payment_chargeanywhere_log'];
		} else {
			$data['log'] = $this->config->get('payment_chargeanywhere_log');
		}

		if (isset($this->request->post['payment_chargeanywhere_sort_order'])) {
			$data['sort_order'] = $this->request->post['payment_chargeanywhere_sort_order'];
			$data['error_warning'] = 'SHOW ERROR';
		} else {
			$data['sort_order'] = $this->config->get('payment_chargeanywhere_sort_order');
		}
		
			
		if (isset($this->request->post['payment_chargeanywhere_setting'])) {
			$data['setting'] = array_replace_recursive((array)$data['setting'], (array)$this->request->post['payment_chargeanywhere_setting']);
		} else {
			$data['setting'] = array_replace_recursive((array)$data['setting'], (array)$this->config->get('payment_chargeanywhere_setting'));
		}
		
		
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}
		//$data['error_warning'] = 'SHOW ERROR';;
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');
		//print_r($data);
		$this->response->setOutput($this->load->view('extension/chargeanywhere/payment/chargeanywhere', $data));
	}

	public function order(): string {
		$this->load->model('localisation/order_status');
		if (isset($this->request->get['order_id'])) {
			$order_id = (int)$this->request->get['order_id'];
		} else {
			$order_id = 0;
		}
		if ($order_id) {
			$this->load->model('sale/order');

			$order_info = $this->model_sale_order->getOrder($order_id);
		}
		$fee_details = htmlspecialchars_decode($order_info['payment_custom_field']['chargeanywhere_fee_details']);
		$fee_details = (array) json_decode($fee_details);
		
		foreach($fee_details as $key => $val){
			$fee_details[$key] = number_format((float)$val, 2, '.', '');
		}
		$data['chargeanywhere_fee_details'] = $fee_details;
		if (!empty($order_info)) {
			$data['order_id'] = $order_info['order_id'];
			$data['order_status_id'] = $order_info['order_status_id'];
		} else {
			$data['order_id'] = '';
			$data['order_status_id'] = 0;
		}
		$data['history'] = $this->getHistory();
		$data['currency'] = $this->config->get('config_currency');
		$data['user_token'] = $this->session->data['user_token'];
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		return $text = $this->load->view('extension/chargeanywhere/payment/order_info', $data);
	}	

	public function getHistory(): string {
		if (isset($this->request->get['order_id'])) 
			$order_id = (int)$this->request->get['order_id'];
		else
			$order_id = 0;

		if (isset($this->request->get['page']))
			$page = (int)$this->request->get['page'];
		else
			$page = 1;

		$data['histories'] = [];
		$this->load->model('sale/order');
		$results = $this->model_sale_order->getHistories($order_id, ($page - 1) * 10, 10);
		foreach ($results as $result) {
			$data['histories'][] = [
				'status'     => $result['status'],
				'comment'    => nl2br($result['comment']),
				'notify'     => $result['notify'] ? $this->language->get('text_yes') : $this->language->get('text_no'),
				'date_added' => date($this->language->get('date_format_short'), strtotime($result['date_added']))
			];
		}
		$history_total = $this->model_sale_order->getTotalHistories($order_id);
		$data['pagination'] = $this->load->controller('common/pagination', [
			'total' => $history_total,
			'page'  => $page,
			'limit' => 10,
			'url'   => $this->url->link('sale/order|history', 'user_token=' . $this->session->data['user_token'] . '&order_id=' . $order_id . '&page={page}')
		]);
		$data['results'] = sprintf($this->language->get('text_pagination'), ($history_total) ? (($page - 1) * 10) + 1 : 0, ((($page - 1) * 10) > ($history_total - 10)) ? $history_total : ((($page - 1) * 10) + 10), $history_total, ceil($history_total / 10));
		return $this->load->view('sale/order_history', $data);
	}
	
	public function save(): void {
		$this->load->language('extension/chargeanywhere/payment/chargeanywhere');
		$this->load->model('extension/chargeanywhere/payment/chargeanywhere');
		if (!$this->user->hasPermission('modify', 'extension/chargeanywhere/payment/chargeanywhere')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		// Setting 		
		$_config = new \Opencart\System\Engine\Config();
		$_config->addPath(DIR_EXTENSION . 'chargeanywhere/system/config/');
		$_config->load('chargeanywhere');
		$setting = $_config->get('chargeanywhere_setting');
		require_once DIR_EXTENSION . 'chargeanywhere/system/library/chargeanywhere.php';
		if (!$this->error) {
			$this->load->model('setting/setting');
			if(preg_match("/tax/i", $this->request->post['payment_chargeanywhere_credit_service'])){
				$data['error'] = 'Credit Service Fee Label should not contain word tax';
			} else if(preg_match("/tax/i", $this->request->post['payment_chargeanywhere_credit_convenience_service'])){
				$data['error'] = 'Credit Convenience Fee Label should not contain word tax';
			} else if(preg_match("/tax/i", $this->request->post['payment_chargeanywhere_ach_service'])){
				$data['error'] = 'ACH Service Fee Label should not contain word tax';
			} else if(preg_match("/tax/i", $this->request->post['payment_chargeanywhere_ach_convenience_service'])){
				$data['error'] = 'ACH Convenience Fee Label should not contain word tax';
			}  else {
				$this->model_setting_setting->editSetting('payment_chargeanywhere', $this->request->post);
				$data['success'] = $this->language->get('success_save');
			}
		}
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($data));
	}

	public function validate_credit_service_fee_field( $key, $value ) {
        // $value = strtolower($value);
         if (preg_match("/tax/i", $value)) {
            WC_Admin_Settings::add_error( 'Credit Service Fee Label should not contain word tax' );
            $value = ''; // empty it because it is not correct
         }
         return $value;
      }
		
	public function disconnect(): void {
		$this->load->model('setting/setting');
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($data));
	}
		
	public function callback(): void {
		if (isset($this->request->post['environment']) && isset($this->request->post['authorization_code']) && isset($this->request->post['shared_id']) && isset($this->request->post['seller_nonce'])) {
			$this->session->data['environment'] = $this->request->post['environment'];
			$this->session->data['authorization_code'] = $this->request->post['authorization_code'];
			$this->session->data['shared_id'] = $this->request->post['shared_id'];
			$this->session->data['seller_nonce'] = $this->request->post['seller_nonce'];
		}
		$data['error'] = $this->error;
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($data));
    }
	
	
	public function call(): void {
		if (isset($this->request->get['action']))
			$action = $this->request->get['action'];
		else
			$action = '';

		if ($action) {
			// 1. Create a store instance using loader class to call controllers, models, views, libraries
			$store = $this->createStoreInstance();

			// 2. Add the request vars and remove the unneeded ones
			$store->request->get = $this->request->get;
			$store->request->post = $this->request->post;
			$store->request->get['route'] = $action;
			unset($store->request->get['action']);
			unset($store->request->get['user_token']);
			
			// Call the required api controller
			$store->load->controller($store->request->get['route']);
			$this->response->addHeader('Content-Type: application/json');
			$this->response->setOutput($store->response->getOutput());
		}
	}

	private function createStoreInstance(): object {
		// Autoloader
		$autoloader = new \Opencart\System\Engine\Autoloader();
		$autoloader->register('Opencart\Catalog', DIR_CATALOG);
		$autoloader->register('Opencart\Extension', DIR_EXTENSION);
		$autoloader->register('Opencart\System', DIR_SYSTEM);

		// Registry
		$registry = new \Opencart\System\Engine\Registry();
		$registry->set('autoloader', $autoloader);

		// Config
		$config = new \Opencart\System\Engine\Config();
		$config->addPath(DIR_CONFIG);
		$registry->set('config', $config);

		// Load the default config
		$config->load('default');
		$config->load('catalog');
		$config->set('application', 'Catalog');

		// Logging
		$registry->set('log', $this->log);

		// Event
		$event = new \Opencart\System\Engine\Event($registry);
		$registry->set('event', $event);

		// Event Register
		if ($config->has('action_event')) {
			foreach ($config->get('action_event') as $key => $value) {
				foreach ($value as $priority => $action) {
					$event->register($key, new \Opencart\System\Engine\Action($action), $priority);
				}
			}
		}

		// Loader
		$loader = new \Opencart\System\Engine\Loader($registry);
		$registry->set('load', $loader);

		// Create a dummy request class so we can feed the data to the order editor
		$request = new \stdClass();
		$request->get = [];
		$request->post = [];
		$request->server = $this->request->server;
		$request->cookie = [];

		// Request
		$registry->set('request', $request);

		// Response
		$response = new \Opencart\System\Library\Response();
		$registry->set('response', $response);

		// Database
		$registry->set('db', $this->db);

		// Cache
		$registry->set('cache', $this->cache);

		// Session
		$session = new \Opencart\System\Library\Session($config->get('session_engine'), $registry);
		$registry->set('session', $session);

		if (isset($this->session->data['api_session'])) {
			$session_id = $this->session->data['api_session'];
		} else {
			$session_id = '';
		}

		$session->start($session_id);

		$this->session->data['api_session'] = $session->getId();

		// To use the order API it requires an API ID.
		$session->data['api_id'] = (int)$this->config->get('config_api_id');

		// Template
		$template = new \Opencart\System\Library\Template($config->get('template_engine'));
		$template->addPath(DIR_CATALOG . 'view/template/');
		$registry->set('template', $template);

		// Language
		if (isset($session->data['language'])) {
			$language_code = $session->data['language'];
		} else {
			$language_code = $this->config->get('config_language');
		}

		// Catalog uses language key in URLs
		$request->get['language'] = $language_code;
		$this->load->model('localisation/language');
		$language_info = $this->model_localisation_language->getLanguageByCode($language_code);
		if ($language_info) {
			$config->set('config_language_id', $language_info['language_id']);
			$config->set('config_language', $language_info['code']);
		} else {
			$config->set('config_language_id', $this->config->get('config_language_id'));
			$config->set('config_language', $language_code);
		}

		$language = new \Opencart\System\Library\Language($language_code);

		if (!$language_info['extension']) {
			$language->addPath(DIR_CATALOG . 'language/');
		} else {
			$language->addPath(DIR_EXTENSION . $language_info['extension'] . '/catalog/language/');
		}

		$language->load($language_code);
		$registry->set('language', $language);

		// Currency
		if (!isset($session->data['currency'])) {
			$session->data['currency'] = $this->config->get('config_currency');
		}

		// Store
		if (isset($session->data['store_id'])) {
			$config->set('config_store_id', $session->data['store_id']);
		} else {
			$config->set('config_store_id', 0);
		}

		// Url
		$registry->set('url', new \Opencart\System\Library\Url($config->get('site_url')));

		// Document
		$registry->set('document', new \Opencart\System\Library\Document());

		// 3. Add the default API ID otherwise will not get a response.
		$session->data['api_id'] = $this->config->get('config_api_id');

		// 4. Run pre actions to load key settings and classes.
		$pre_actions = [
			'startup/setting',
			'startup/extension',
			'startup/customer',
			'startup/tax',
			'startup/currency',
			'startup/application',
			'startup/startup',
			'startup/event'
		];

		// Pre Actions
		foreach ($pre_actions as $pre_action) {
			$loader->controller($pre_action);
		}

		// Customer
		$customer = new \Opencart\System\Library\Cart\Customer($this->registry);
		$registry->set('customer', $customer);
		return $registry;
	}
	
	public function install() {
		$this->load->model('setting/setting');
		$this->model_setting_setting->editValue('config', 'config_session_samesite', 'Lax');
	}
					
	private function token($length = 32): string {
		// Create random token
		$string = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
		$max = strlen($string) - 1;
		$token = '';
		for ($i = 0; $i < $length; $i++) {
			$token .= $string[mt_rand(0, $max)];
		}	
		return $token;
	}
}