<?php
namespace Opencart\Catalog\Model\Extension\ChargeAnywhere\Payment;
class Chargeanywhere extends \Opencart\System\Engine\Model {
	public function getMethod(array $address): array {
		$this->load->language('extension/chargeanywhere/payment/chargeanywhere');
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('payment_chargeanywhere_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");
		$status = true;
		$method_data = [];

		if ($status) {
			$method_data = [
				'code'       => 'chargeanywhere',
				'title'      => $this->language->get('text_title'),
				'sort_order' => $this->config->get('payment_chargeanywhere_sort_order')
			];
		}
		return $method_data;
	}
	
	public function log(array $data = [], string $title = ''): void {
		if ($this->config->get('payment_chargeanywhere_debug')) {
			$log = new \Opencart\System\Library\Log('chargeanywhere.log');
			$log->write('Charge Anywhere debug (' . $title . '): ' . json_encode($data));
		}
	}

	public function updatePaymentCustomDetails($order_id, $payment_custom_fields){
		$this->db->query("UPDATE `" . DB_PREFIX . "order` SET `payment_custom_field` = '" . $this->db->escape($payment_custom_fields) . "' WHERE `order_id` = '" . (int)$order_id . "'");
	}
}